<template>
  <div class="container centered">
    <h1>Liste des utilisateurs</h1>
    <hr>

    <form class="filterform" @submit.prevent>
      <input type="search" v-model="userSearch" placeholder="Tapez un nom ou un lieu ...">

      <label for="filter">Filtrer par :</label>
      <select name="filterBy" v-model="filterValue">
        <option value="name">Nom</option>
        <option value="localisation">Localisation</option>
      </select>
    </form>

    <div class="userlist" v-if="usersList">
      <Usercard v-for="user in filteredList" :user="user" :key="user.id" @remove="removeUser"/>
    </div>
  </div>
</template>

<script>
import Usercard from "./Usercard.vue";
import UserService from "../services/UserService.js";

export default {
  name: "List",
  components: {
    Usercard
  },
  data: function() {
    return {
      usersList: null,
      filterValue: "name"
    };
  },
  computed: {
    userSearch: {
      get: function() {
        return this.$store.state.userSearch;
      },
      set: function(newVal) {
        this.$store.dispatch("updateUserSearch", newVal);
      }
    },
    filteredList: function() {
      return this.usersList.filter(({ lastname, firstname, city }) => {
        let searchText = this.$store.state.userSearch.toLowerCase();
        firstname = firstname.toLowerCase();
        lastname = lastname.toLowerCase();
        city = city.toLowerCase();

        return this.filterValue === "name"
          ? `${lastname} ${firstname}`.includes(searchText) ||
              `${firstname} ${lastname}`.includes(searchText)
          : city.includes(searchText);
      });
    }
  },
  methods: {
    removeUser: function(userToDelete) {
      UserService.removeUser(userToDelete)
        .then(res => {
          let index = this.usersList.indexOf(userToDelete);
          if (index > -1) {
            this.usersList.splice(index, 1);
          }
          this.$toasted.success(
            `Collaborateur ${res.removed.firstname} supprimé ! 💪`
          );
        })
        .catch(({ message }) => this.$toasted.error(message));
    }
  },
  created: function() {
    UserService.fetchAll().then(usersList => {
      this.usersList = usersList;
    });
  }
};
</script>

<style scoped>
.userlist {
  display: flex;
  flex-wrap: wrap;
}

.userlist > * {
  box-sizing: border-box;
  width: calc(94% / 3);
  margin: 1%;
}

.filterform {
  margin: 2em 0;
}
</style>
